local MyName="vZifnabsEmotor"
local Me=CreateFrame("Frame",MyName)
local mypfx="vZifnabs_Emotor"
vZifnabs.mod.emotor=Me
local mod=vZifnabs.mod
local db={}
local L={}

local dblist={}
local infight=false
local summoning={}
local startedspell=nil
local fishing={last=0,now=false}
local lastemotor={}
local undeflist={}
local playername=UnitName("player")
local playerclass=UnitClass("player")
local DEFAULT={RATIO=100,NOREPEAT=120,NOMOVE=120}
local petstay=false

local config={}
local widget={selector={}, check={}, edit={}}

-- Slash Commands
SLASH_VZIFNABSEMOTOR1 = "/ze"
SlashCmdList["VZIFNABSEMOTOR"]=function (cmd) Me:SlashCommand(cmd) end

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db,L=mod.core:InitStart("emotor")
	if not db.emotor then db.emotor={petname={},list={},repl={},classify={}} end
	
	for list,data in pairs(L.emotor.list) do
		if not db.emotor.list[list] then 
			db.emotor.list[list]={options=L.emotor.list[list].options,route=L.emotor.list[list].route}
			for tgt,subdata in pairs(data) do
				if tgt~="options" and tgt~="route" then
					-- z.B. tgt="NOTARGET"
					db.emotor.list[list][tgt]={}
					for emosay,textlist in pairs(subdata) do
						db.emotor.list[list][tgt][emosay]={}
						for nr,text in pairs(textlist) do db.emotor.list[list][tgt][emosay][nr]={text=text} end
					end
				end
			end
			mod.core:Print(mod.core:Repl(L.msg.insertlist,"<list>",list))
		end
	end
	Me:BuildLists()
	
	for key,list in pairs(L.emotor.repl) do
		if not db.emotor.repl[key] then db.emotor.repl[key]=list end
	end
	
	mod.core:RegisterEvent("ONUPDATE","emotor",Me.OnUpdate)
	mod.core:RegisterEvent("PLAYER_REGEN_DISABLED","emotor",Me.PLAYER_REGEN_DISABLED)
	mod.core:RegisterEvent("PLAYER_REGEN_ENABLED","emotor",Me.PLAYER_REGEN_ENABLED)
	mod.core:RegisterEvent("SPELLCAST_START","emotor",Me.SPELLCAST_START)
	mod.core:RegisterEvent("SPELLCAST_CHANNEL_START","emotor",Me.SPELLCAST_CHANNEL_START)
	mod.core:RegisterEvent("SPELLCAST_CHANNEL_STOP","emotor",Me.SPELLCAST_CHANNEL_STOP)
	
	Me:ConfigInitialize()
	mod.core:InitStop("emotor")
end

function Me:OnUpdate()
	local petname=UnitName("pet")
	if not db.emotor.petname[playername] then db.emotor.petname[playername]={} end
	if petname and summoning.slot then
		if petname~=L.keyword.unknown and petname~=summoning.current then
			db.emotor.petname[playername][summoning.slot]=petname 
			db.emotor.petname[playername].current=petname
			summoning={}
		elseif petname~=L.keyword.unknown and time()-(summoning.start or 0)>11 then
			if db.emotor.petname[playername][summoning.slot] then db.emotor.petname[playername].current=db.emotor.petname[playername][summoning.slot] end
			summoning={}
		end
	elseif petname and petname~=L.keyword.unknown and petname~=db.emotor.petname[playername].current then
		db.emotor.petname[playername].current=petname
	end
end

-- -----------------------------------------------------------------
-- PLAYER REGEN EN/DISABLED
-- -----------------------------------------------------------------
function Me:PLAYER_REGEN_DISABLED() 
	infight=true 
	Me:checkFishingFight()
end

function Me:PLAYER_REGEN_ENABLED() 
	infight=false 
end

-- -----------------------------------------------------------------
-- SPELLCAST START
-- -----------------------------------------------------------------
function Me:SPELLCAST_START(event,spell,number,more)
	summoning={}
	startedspell=spell
	local given_sublist=nil
	local word=mod.core:Split(spell," ")
	if spell==L.keyword.soulstone then 
		local sstarget=UnitName("player")
		if UnitInParty("target") or UnitInRaid("target") then sstarget=UnitName("target") end
		if sstarget==UnitName("player") then given_sublist="NOTARGET" end
		mod.core:Print(mod.core:Repl(L.msg.soulstoneset,"<target>",sstarget))
		local storetime=30*60 -- 29*60+30 -- sollten eigentlich 30min sein, real aber offenbar eher 29:30
		mod.scheduler:Remind(storetime-120,mod.core:Repl(L.msg.soulstonerest,{"<tgt>","<rest>"},{sstarget,"120"}))
		mod.scheduler:Remind(storetime-60,mod.core:Repl(L.msg.soulstonerest,{"<tgt>","<rest>"},{sstarget,"60"}))
		mod.scheduler:Remind(storetime-20,mod.core:Repl(L.msg.soulstonerest,{"<tgt>","<rest>"},{sstarget,"20"}))
		mod.scheduler:Remind(storetime,mod.core:Repl(L.msg.soulstoneout,"<tgt>",sstarget))
	elseif word[1]==L.keyword.summon then
		if not db.emotor.petname[playername] then db.emotor.petname[playername]={} end
		local petname=db.emotor.petname[playername][word[2]] or word[2] or ""
		if petname=="Unknown" then petname=word[2] or "" end
		summoning={slot=word[2],current=UnitName("pet"),start=time()} 
	end
	Me:emotor(spell,given_sublist)
end

-- -----------------------------------------------------------------
-- SPELLCAST CHANNEL START
-- -----------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_START(event,duration,spell,rank)
	if spell==L.keyword.fishing then
		if fishing.last==0 or time()-fishing.last>120 then spell=spell.." Begin" end
		fishing={last=time(),now=true}
	elseif playerclass=="WARLOCK" and duration==15000 then spell="Soul Drain" 
	end
	startedspell=spell
	Me:emotor(spell)
end

-- -----------------------------------------------------------------
-- SPELLCAST CHANNEL STOP
-- -----------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_STOP(event,wtf,spell,rank)
	Me:checkFishingFight()
	fishing.now=false
end

-- -----------------------------------------------------------------
-- CHECK ATTACK WHILE FISHING?
-- -----------------------------------------------------------------
function Me:checkFishingFight()
	if infight and fishing.now then	Me:emotor("Attack while fishing") end
end

-- -----------------------------------------------------------------
-- SLASH COMMAND
-- -----------------------------------------------------------------
function Me:SlashCommand(cmd)
	local word=mod.core:Split(mod.core:Trim(string.lower(cmd))," ")
	if word[1]=="pet" then 
		Me:Pet(word[2])
	elseif word[1]=="reload" then
		db.emotor.list={}
		for list,data in pairs(L.emotor.list) do
			db.emotor.list[list]={}
			for sublist,subdata in pairs(data) do
				if sublist=="options" then db.emotor.list[list].options=subdata
				elseif sublist=="route" then db.emotor.list[list].route=subdata
				else
					db.emotor.list[list][sublist]={text={},emotes={}}
					for emosay,txlist in pairs(subdata) do
						for nr,text in txlist do
							db.emotor.list[list][sublist][emosay][nr]={text=text}
						end
					end
				end
			end
			
		end
		db.emotor.repl=L.emotor.repl
		mod.core:Print(L.msg.ok)
	elseif db.emotor.list[word[1]] then
		Me:emotor(word[1],word[2])
	else
		mod.core:Print(mod.core:Repl(L.msg.undefinedlist,"<list>",word[1] or "nil"))
	end
end

function Me:Pet(cmd)
	if cmd=="attack" then
		PetAttack()
		Me:emotor("Pet Attack")
	elseif cmd=="dismiss" then
		PetDismiss()
		Me:emotor("Pet Dismiss")
	elseif cmd=="stay" then
		PetWait()
		Me:emotor("Pet Stay")
		petstay=true
	elseif cmd=="follow" then
		PetFollow()
		PetDefensiveMode()
		if petstay then Me:emotor("Pet Follow") else Me:emotor("Pet StopFight") end
		petstay=false
	elseif cmd=="passive" then
		PetPassiveMode()
	else
		mod.core:Print(mod.core:Repl(L.msg.undefparm,"<parm>",cmd or "nil"))
	end
end

-- -----------------------------------------------------------------
-- EMOTOR
-- -----------------------------------------------------------------
function Me:emotor(originallist,given_sublist)
	local list=originallist
	if db.emotor.list[originallist] and db.emotor.list[originallist].route then list=db.emotor.list[originallist].route end
	if not db.emotor.list[list] then
		if not undeflist[list] or time()-undeflist[list]>300 then
			mod.core:Print(mod.core:Color(mod.core:Repl(L.msg.undefinedlist,"<list>",list),"808080"))
			undeflist[list]=time()
		end
	else
		local px,py,zone,pos=mod.locator:GetLoc()
		local options=db.emotor.list[list].options
		if options[playername] then options=options[playername] end
		local rand=math.random(100)
		local ratio=(options.ratio or DEFAULT.RATIO)
		local llist=list
		if string.sub(list,1,4)=="Pet " then llist="pet" end
		if not lastemotor[llist] then lastemotor[llist]={etime=0,pos=0} end
		local last=time()-lastemotor[llist].etime
		if last<(options.norepeat or 0) then
		elseif last<(options.nomove or 0) and pos==lastemotor[llist].pos then
		elseif rand>ratio then
		elseif rand<=ratio then
			lastemotor[llist]={etime=time(),pos=pos}
			local targetname=UnitName("target") or ""
			local petname=UnitName("pet") or ""
			if petname==L.keyword.unknown or petname=="" then
				petname=db.emotor.petname[playername].current or "" 
			end
			local cursorname=getglobal("GameTooltipTextLeft1"):GetText() or ""
			-- Strip unwanted prefixes and sufixes from target and cursor
			targetname=Me:Strip(targetname)
			cursorname=Me:Strip(cursorname)

			-- sublist wählen
			local sublist=given_sublist or "ALWAYS"
			if not dblist[list][sublist] then
				if not UnitExists("target") then sublist="NOTARGET"
				else
					sublist="TARGET"
					local target=UnitName("target")
					if db.emotor.classify[target] and db.emotor.classify[target][playername] and dblist[list][db.emotor.classify[target][playername]] then
						sublist=db.emotor.classify[target][playername]
					elseif dblist[list]["KNOWN"] and GetGuildInfo("target")==(GetGuildInfo("player") or "") then
						sublist="KNOWN"
					elseif dblist[list]["KNOWN"] and UnitInParty("target") or UnitInRaid("target") then
						sublist="KNOWN"
					elseif dblist[list]["KNOWN"] and mod.targets:IsKnown(UnitName("target")) then
						sublist="KNOWN"
					elseif dblist[list]["ENEMY"] and UnitCanAttack("player","target") then
						sublist="ENEMY"
					end
				end
			end -- not sublist
			
			if list==L.keyword.redemption then
				if cursorname==L.keyword.redemption or cursorname==nil or cursorname=="" then cursorname=targetname end
			end
		
			-- entry wählen und aufbereiten
			local say=Me:SelectListEntry(dblist[list][sublist].text,list.."."..sublist..".text")
			local emo=Me:SelectListEntry(dblist[list][sublist].emotes,list.."."..sublist..".emotes")
			if say and string.find(say,"&&") then 
				local split=mod.core:Split(say,"&&",2)
				say=split[1]
				emo=split[2]
			end
			if dblist[list].options.special then say,emo=Me:Special(originallist,say,emo) end
			
			local channel="SAY"
			local language=nil -- TODO language wählen
			if say and strlower(string.sub(say,1,3))=="/y " then
				say=mod.core:Trim(string.sub(say,3))
				channel="YELL"
			end
		
			if say then say=mod.core:Repl(say,{"<.>","<!>","<#>","<pet>"},{playername,targetname,cursorname,petname}) end
			if emo then emo=mod.core:Repl(emo,{"<.>","<!>","<#>","<pet>"},{playername,targetname,cursorname,petname}) end
			
			local playersex=UnitSex("player")
			local targetsex=UnitSex("target") or 1
			if targetsex==1 then targetsex=Me:GetSex(targetname) end
			local cursorsex=Me:GetSex(cursorname)
			for key,list in pairs(db.emotor.repl) do
				if say then say=Me:ReplKey(say,key,{list[playersex],list[targetsex],list[cursorsex]}) end
				if emo then emo=Me:ReplKey(emo,key,{list[playersex],list[targetsex],list[cursorsex]}) end
			end
			
			local race=UnitRace("target") or UnitCreatureFamily("target") or UnitClass("target") or "Whatever"
			if say then say=mod.core:Repl(say,{"<!race>"},{race}) end
			if emo then emo=mod.core:Repl(emo,{"<!race>"},{race}) end
		
			-- Ausgabe von emote und say
			if emo and emo~="" then
				if string.sub(emo,1,1)=="/" then DoEmote(string.sub(emo,2))	else SendChatMessage(emo,"EMOTE") end
			end
			local defaultlang="Common"
			if UnitFactionGroup("player")=="Horde" then defaultlang="Orcish" end
			if say and say~="" then SendChatMessage(say,channel,(language or defaultlang)) end
		end -- rand>ratio
	end -- if emotor[list]
end

function Me:ReplKey(text,key,repllist)
	text=mod.core:Repl(text,{"<."..key..">","<!"..key..">","<#"..key..">"},repllist)
	local ukey=Me:Up(key)
	local urepl={Me:Up(repllist[1]),Me:Up(repllist[2]),Me:Up(repllist[3])}
	text=mod.core:Repl(text,{"<."..ukey..">","<!"..ukey..">","<#"..ukey..">"},repllist)
	return text
end
function Me:Up(text) return string.upper(string.sub(text,1,1))..string.sub(text,2) end

function Me:SelectListEntry(list,debuginfo)
	list.next=list.next+math.random(2)
	if list.next>list.max then list.next=list.next-list.max end
	return list[list.next]
end

-- -----------------------------------------------------------------
-- SELECT ENTRIES
-- -----------------------------------------------------------------
function Me:BuildLists()
	for list,data in pairs(db.emotor.list) do
		dblist[list]={}
		for sublist,subdata in pairs(data) do
			if sublist=="options" then dblist[list].options=subdata
			elseif sublist=="route" then dblist[list].route=subdata
			else
				dblist[list][sublist]={}
				for emosay,esdata in pairs(subdata) do
					dblist[list][sublist][emosay]={}
					local rn=0
					for nr,entry in pairs(esdata) do
						if not entry.skip or not entry.skip[playername] then
							rn=rn+1
							dblist[list][sublist][emosay][rn]=entry.text
						end
					end
					if rn==0 then 
						dblist[list][sublist][emosay]=nil 
					else
						dblist[list][sublist][emosay].max=rn
						dblist[list][sublist][emosay].next=1
					end
				end
				if not dblist[list][sublist].emotes and not dblist[list][sublist].text then dblist[list][sublist]=nil end
			end
		end
	end
end

-- -----------------------------------------------------------------
-- SPECIAL
-- -----------------------------------------------------------------
function Me:Special(listname,say,emo)
	local word=mod.core:Split(listname," ")
	if word[1]==L.keyword.summon then
		local petname=db.emotor.petname[playername][word[2]] or word[2] or ""
		if petname=="Unknown" then petname=word[2] or "" end
		say=mod.core:Repl(say,"<pet>",petname)
		emo=mod.core:Repl(emo,"<pet>",petname)
		if petname==word[2] then summoning={slot=word[2],current=UnitName("pet")} end
	end
	return say,emo
end

-- -----------------------------------------------------------------
-- STRIP
-- -----------------------------------------------------------------
function Me:Strip(name)
	for n=1,getn(L.emotor.stripprefix),1 do	
		if string.find(name,L.emotor.stripprefix[n])==1 then name=string.sub(name,string.len(L.emotor.stripprefix[n])+1) end
	end
	return name
end

-- -----------------------------------------------------------------
-- GETSEX
-- -----------------------------------------------------------------
function Me:GetSex(name)
	local sex=1
	-- TODO search through sexlist for sex of "name"
	return sex
end

-- -----------------------------------------------------------------
-- CONFIGURATION INITIALIZATION
-- -----------------------------------------------------------------
function Me:ConfigInitialize()
	local listselector=mypfx.."_Config_ListSelector"
	widget.listselector=getglobal(listselector)
	widget.selectup=getglobal(listselector.."_Up")
	widget.selectdown=getglobal(listselector.."_Down")
	widget.sublist={}
	for nr,sublist in {"ALWAYS","NOTARGET","TARGET","KNOWN","ENEMY","text","emotes"} do
		widget.sublist[sublist]=getglobal(mypfx.."_Config_SubSelector_"..sublist)
		widget.sublist[sublist].selectsub=sublist
		widget.sublist[sublist]:SetText(L.emotor.configs.sublist[sublist] or sublist)
	end
	local xoff=0
	for b=1,20,1 do
		local button=getglobal(listselector.."_"..b)
		button:ClearAllPoints()
		button:SetPoint("TOPLEFT",listselector,"TOPLEFT",5+160*xoff,-20*math.floor((b-1)/4)-5)
		button:Hide()
		button.buttonnr=b
		widget.selector[b]=button
		xoff=xoff+1
		if xoff==4 then xoff=0 end
	end
	
	local parent=mypfx.."_Config_Edit"
	for t=1,12,1 do
		widget.check[t]=getglobal(parent.."_Use_"..t)
		widget.edit[t]=getglobal(parent.."_Text_"..t)
		widget.check[t].textnr=t
		widget.edit[t].textnr=t
		widget.check[t]:ClearAllPoints()
		widget.check[t]:SetPoint("TOPLEFT",parent,"TOPLEFT",630,10-25*t)
		widget.edit[t]:ClearAllPoints()
		widget.edit[t]:SetPoint("TOPLEFT",parent,"TOPLEFT",5,10-25*t)
		widget.edit[t]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil});
		widget.edit[t]:SetBackdropColor(0.5,0.5,0.5,1);
	end
	widget.editup=getglobal(parent.."_Up")
	widget.editdown=getglobal(parent.."_Down")
	
	for metric,cc in pairs {ratio={slider="Ratio",max=100}, norepeat={slider="NoRepeat",max=300}, nomove={slider="NoMove",max=300}} do
		widget[metric]=mod.config:InitializeSlider(mypfx.."_Config_Options_"..cc.slider,0,cc.max,1,1,L.emotor.configs[metric].text,L.emotor.configs[metric].tt)
		widget[metric].slider.exitmodule=Me
		widget[metric].slider.valuename=metric
	end

	mod.config:Register(Me,L.button.emotor.config,"vZifnabs_Emotor_Config")
end

-- -----------------------------------------------------------------
-- CONFIGURATION START
-- -----------------------------------------------------------------
function Me:ConfigStart(selection,subselect)
	if selection then config.selected=selection
	else
		config={unsaved=false,top=0,selected=1,etop=0,emaxtop=0,emosay="text",list={},val={}}
		local order={}
		for list,data in pairs(db.emotor.list) do
			if not data.options then mod.core:Print("INTERNAL ERROR: no options entry for "..list)
			elseif not data.options.order then mod.core:Print("INTERNAL ERROR: no order number for list "..list)
			elseif order[data.options.order] then mod.core:Print("INTERNAL ERROR: "..list.." uses same order number as "..order[data.options.order].list)
			else order[data.options.order]={name=list,data=data} end
		end

		local l=0
		for o=1,999,1 do
			if order[o] then
				l=l+1
				config.list[l]=order[o]
			end
		end
		config.maxtop=math.max(0,l-19)
	end
	
	if not subselect then
		if config.list[config.selected].data.route then config.subselect="route"
		elseif config.list[config.selected].data["ALWAYS"] then config.subselect="ALWAYS" 
		else config.subselect="NOTARGET" end
	
		for metric,default in {ratio=DEFAULT.RATIO,norepeat=DEFAULT.NOREPEAT,nomove=DEFAULT.NOMOVE} do
			config.val[metric]={init=config.list[config.selected].data[metric] or default}
			if config.list[config.selected].data.options and config.list[config.selected].data.options[metric] then 
				config.val[metric].init=config.list[config.selected].data.options[metric] 
			end
			if config.list[config.selected].data.options and config.list[config.selected].data.options[playername] and config.list[config.selected].data.options[playername][metric] then 
				config.val[metric].init=config.list[config.selected].data.options[playername][metric]
			end
			config.val[metric].now=config.val[metric].init
		end
	end
	
	if config.subselect~="route" then
		config.val.texts={init={},now={}}
		for nr,text in db.emotor.list[config.list[config.selected].name][config.subselect][config.emosay] do
			config.val.texts.init[nr]={text=text.text}
			config.val.texts.now[nr]={text=text.text}
			if text.skip then 
				config.val.texts.init[nr].skip=mod.core:Clone(text.skip) 
				config.val.texts.now[nr].skip=mod.core:Clone(text.skip) 
			end
			config.maxetop=nr-11
		end
	end
	
	Me:SelectShow()
end

-- -----------------------------------------------------------------
-- CONFIGURATION SAVE
-- -----------------------------------------------------------------
function Me:ConfigSave()
	local dbtext={}
	local dboptions=db.emotor.list[config.list[config.selected].name].options
	if not dboptions then dboptions={} end
	for metric,data in pairs(config.val) do
		if metric=="texts" then
			local newnr=0
			dbtext={}
			for nr,entry in pairs(data.now) do
				local txt=mod.core:Trim(entry.text or "")
				if txt~="" then
					newnr=newnr+1
					dbtext[newnr]={text=txt}
					if entry.skip then 
						for player,skip in pairs(entry.skip) do
							if skip then
								if not dbtext[newnr].skip then dbtext[newnr].skip={[player]=true} else dbtext[newnr].skip[player]=true end
							end
						end
					end
				end
			end
		elseif not dboptions[metric] then 
			dboptions[metric]=data.now
		else
			if not dboptions[playername] then dboptions[playername]={} end
			dboptions[playername][metric]=data.now
		end
		data.init=data.now
	end
	db.emotor.list[config.list[config.selected].name][config.subselect][config.emosay]=dbtext
	config.unsaved=false
	mod.config:SetUnsavedChanges(config.unsaved)
	Me:BuildLists()
end

-- -----------------------------------------------------------------
-- CONFIGURATION DROP & STOP
-- -----------------------------------------------------------------
function Me:ConfigDrop() Me:ConfigStart() end
function Me:ConfigStop() config={} end

-- -----------------------------------------------------------------
-- SELECT LIST button clicked
-- -----------------------------------------------------------------
function Me:SelectList(button)
	if config.unsaved then
		mod.config.WarnUnsavedChanges()
	elseif button.selectsub then 
		if button.selectsub=="emotes" or button.selectsub=="text" then
			config.emosay=button.selectsub
		else
			config.subselect=button.selectsub
		end
		Me:ConfigStart(config.selected,true)
	else
		Me:ConfigStart(config.top+button.buttonnr)
	end
end

-- -----------------------------------------------------------------
-- SELECT SCROLL button clicked
-- -----------------------------------------------------------------
function Me:SelectScroll(direction)
	config.top=math.max(0,config.top+direction)
	if config.top==0 then widget.selectup:Hide() else widget.selectup:Show() end
	if config.top>=config.maxtop then widget.selectdown:Hide() else widget.selectdown:Show() end
	if direction~=0 then Me:SelectShow() end
end

-- -----------------------------------------------------------------
-- EDIT SCROLL button clicked
-- -----------------------------------------------------------------
function Me:EditScroll(direction)
	config.etop=math.max(0,config.etop+direction)
	if config.etop==0 then widget.editup:Hide() else widget.editup:Show() end
	if config.etop>=config.maxetop then widget.editdown:Hide() else widget.editdown:Show() end
	if direction~=0 then Me:SelectShow() end
end

-- -----------------------------------------------------------------
-- SHOW SELECTED LIST
-- -----------------------------------------------------------------
function Me:SelectShow()
	config.prepare=true
	for b=1,20,1 do
		local bs=b+config.top
		if config.list[bs] then
			widget.selector[b]:SetText(config.list[bs].name)
			widget.selector[b]:Show()
		else
			widget.selector[b]:Hide()
		end
		if bs==config.selected then widget.selector[b]:Disable() else widget.selector[b]:Enable() end
	end
	
	if config.emosay=="text" then widget.sublist.emotes:Enable() else widget.sublist.text:Enable() end
	widget.sublist[config.emosay]:Disable()
	
	for nr,sublist in {"ALWAYS","NOTARGET","TARGET","KNOWN","ENEMY"} do
		if sublist==config.subselect then widget.sublist[sublist]:Disable() else widget.sublist[sublist]:Enable() end
		if config.subselect=="ALWAYS" then
			if sublist=="ALWAYS" then widget.sublist[sublist]:Show() else widget.sublist[sublist]:Hide() end
		else
			if sublist=="ALWAYS" then widget.sublist[sublist]:Hide() else widget.sublist[sublist]:Show() end
		end
	end
	Me:SelectScroll(0) -- to show/hide scroll buttons

	if config.subselect=="route" then
		getglobal(mypfx.."_Config_SubSelector"):Hide()
		getglobal(mypfx.."_Config_Options"):Hide()
		getglobal(mypfx.."_Config_Edit"):Hide()
	else
		getglobal(mypfx.."_Config_SubSelector"):Show()
		getglobal(mypfx.."_Config_Options"):Show()
		getglobal(mypfx.."_Config_Edit"):Show()
		for metric,data in pairs(config.val) do
			if metric~="texts" then widget[metric].slider:SetValue(config.val[metric].now) end
		end
		for t=1,12,1 do
			local ts=t+config.etop
			if config.val.texts.now[ts] then
				widget.edit[t]:SetText(config.val.texts.now[ts].text or "")
				widget.check[t]:SetChecked((not config.val.texts.now[ts].skip or not config.val.texts.now[ts].skip[playername]))
			else
				widget.edit[t]:SetText("")
				widget.check[t]:SetChecked(false)
			end
		end
	end
	Me:EditScroll(0) -- to show/hide scroll buttons

	widget.listselector:Show()
	config.prepare=false
end

-- -----------------------------------------------------------------
-- CHECK UNSAVED
-- -----------------------------------------------------------------
function Me:CheckUnsaved()
	if not config.prepare then
		config.unsaved=false
		for name,data in pairs(config.val) do 
			if name=="texts" then 
				for nr,entry in pairs(config.val.texts.now) do
					local init=config.val.texts.init[nr]
					if entry.text~=init.text then 
						config.unsaved=true 
					elseif (entry.skip and not init.skip) or (not entry.skip and init.skip) then 
						config.unsaved=true
					elseif entry.skip then
						for player,skip in pairs(entry.skip) do
							if skip~=(init.skip and init.skip[player]) then config.unsaved=true end
						end
					end
				end
			else
				config.unsaved=config.unsaved or data.init~=data.now 
			end
		end
		mod.config:SetUnsavedChanges(config.unsaved) 
	end
end

-- -----------------------------------------------------------------
-- SLIDER value changed
-- -----------------------------------------------------------------
function Me:SliderValueChanged(widget,effectivevalue)
	config.val[widget.valuename].now=effectivevalue
	Me:CheckUnsaved()
end

-- -----------------------------------------------------------------
-- CHECK BOX clicked
-- -----------------------------------------------------------------
function Me:Check(widget)
	local nr=widget.textnr+config.etop
	local entry=config.val.texts.now[widget.textnr+config.etop]
	local skip=(not widget:GetChecked())
	if not config.val.texts.now[nr] then config.val.texts.now[nr]={text="",skip={}} end
	if not config.val.texts.init[nr] then config.val.texts.init[nr]={text="",skip={}} end
	if not skip then skip=nil end
	config.val.texts.now[nr].skip[playername]=skip
	Me:CheckUnsaved()
end

-- -----------------------------------------------------------------
-- EDIT BOX changed
-- -----------------------------------------------------------------
function Me:Edit(widget)
	local nr=widget.textnr+config.etop
	local text=mod.core:Trim(widget:GetText() or "")
	if not config.val.texts.now[nr] then config.val.texts.now[nr]={text="",skip={}} end 
	if not config.val.texts.init[nr] then config.val.texts.init[nr]={text="",skip={}} end
	config.val.texts.now[nr].text=text
	Me:CheckUnsaved()
end