local Me=CreateFrame("Frame","vZifnabsHealer")
vZifnabs.mod.healer=Me
local mod=vZifnabs.mod
local L={}
local db=nil
local widget={}
local stats=nil
local playername=UnitName("player")

local eventlist={
	"CHAT_MSG_SPELL_SELF_BUFF",
	"CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS",
	"CHAT_MSG_SPELL_FRIENDLYPLAYER_BUFF",
	"CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_BUFFS",
	"CHAT_MSG_SPELL_PARTY_BUFF",
	"CHAT_MSG_SPELL_PERIODIC_PARTY_BUFFS",
}

-- Slash Commands
SLASH_VZIFNABSHEALER1 = "/zh"
SlashCmdList["VZIFNABSHEALER"]=function (parm) Me:Command(parm) end

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db,L=mod.core:InitStart("healer")
	widget={frame=getglobal("vZifnabs_Healer"),
			title=getglobal("vZifnabs_Healer_Title"),
			button={delete=getglobal("vZifnabs_Healer_Delete"),reset=getglobal("vZifnabs_Healer_Reset"),scroll=getglobal("vZifnabs_Healer_Scroll")},
			list={},
			}
	for l=1,10,1 do
		widget.list[l]={
			spell=getglobal("vZifnabs_Healer_List_"..l.."_Spell"),
			count=getglobal("vZifnabs_Healer_List_"..l.."_Count"),
			average=getglobal("vZifnabs_Healer_List_"..l.."_Average"),
			critpercent=getglobal("vZifnabs_Healer_List_"..l.."_CritPercent"),
			critaverage=getglobal("vZifnabs_Healer_List_"..l.."_CritAverage"),
		}
	end
	mod.core:RegisterButton("healer","delete",L.button.healer.delete,"vZifnabs_Healer_Delete")	
	mod.core:RegisterButton("healer","reset",L.button.healer.reset,"vZifnabs_Healer_Reset")	
	mod.core:RegisterButton("healer","scroll",L.button.healer.scroll,"vZifnabs_Healer_Scroll")				
			
	for nr,event in eventlist do
		mod.core:RegisterEvent(event,"healer",Me.OnEvent)
	end
	mod.core:RegisterButton("healer","flip",L.button.healer.flip)
	
	if db.healer and db.healer[playername] and db.healer[playername].show then Me:Command(mod.core:Trim("set "..(db.healer[playername].current or ""))) end
	Me:ShowList()
	
	mod.core:InitStop("healer")
end

-- -----------------------------------------
-- ON EVENT
-- -----------------------------------------
function Me:OnEvent(event,msg,v2,v3,v4)
	local lowmsg=string.lower(msg or "")
	local heals=string.find(lowmsg,L.keyword.BhealsB)
	local yourb=string.find(lowmsg,L.keyword.yourB)
	if heals and (yourb or 0)==1 then
		local crit=string.find(lowmsg,L.keyword.BcriticallyB)
		local spell=string.sub(msg,string.len(L.keyword.yourB)+1,(crit or heals))
		local whom=string.sub(msg,heals+string.len(L.keyword.BhealsB))
		local amount=string.sub(whom,string.find(whom,L.keyword.BforB)+string.len(L.keyword.BforB))
		if string.find(amount,".") then amount=string.sub(amount,1,string.len(amount)-1) end
		amount=tonumber(amount)
		whom=string.sub(whom,1,string.find(whom," ")-1)
		if not stats then Me:Command("set") end
		if not stats[spell] then stats[spell]={regular={count=0, amount=0}, crit={count=0,amount=0}} end
		if crit then
			stats[spell].crit.count=stats[spell].crit.count+1
			stats[spell].crit.amount=stats[spell].crit.amount+amount
		else
			stats[spell].regular.count=stats[spell].regular.count+1
			stats[spell].regular.amount=stats[spell].regular.amount+amount
		end
		db.healer[playername].sets[db.healer[playername].current]=stats -- sollte eigentlich nicht nötig sein?
		Me:ShowList()
	elseif msg and db.debug then
		mod.core:Print(string.sub(event,10)..": "..msg.."\nlow='"..(lowmsg or "nil").."'\nyourb="..(yourb or 0)..", heal="..(heals or 0))
	end
end

-- -----------------------------------------
-- SHOW LIST
-- -----------------------------------------
function Me:ShowList()
	if not db.healer or not db.healer[playername] or not db.healer[playername].show then
		widget.frame:Hide()
	else
		local l=0
		local list={[0]={spell="",count="",ravg="",cperc="",cavg=""}}
		for spell,info in pairs(stats) do
			l=l+1
			list[l]={
					 spell=spell,
					 count=info.regular.count+info.crit.count,
					 ravg=math.ceil(info.regular.amount/math.max(1,info.regular.count)),
					 cperc=math.ceil(100*info.crit.count/(info.regular.count+info.crit.count)).."%",
					 cavg=math.ceil(info.crit.amount/math.max(1,info.crit.count)),
					}
		end
		for l=1,5,1 do
			if widget.list[l] and widget.list[l].spell then
				local high={val=0,nr=0}
				local s=0
				for s=1,5,1 do
					if list[s] and list[s].count>high.val then high={val=list[s].count,nr=s} end
				end
				s=high.nr
				if string.len(list[s].spell)<18 then widget.list[l].spell:SetText(list[s].spell) else widget.list[l].spell:SetText(string.sub(list[s].spell,1,15).."...") end
				widget.list[l].count:SetText(list[s].count)
				widget.list[l].average:SetText(list[s].ravg)
				widget.list[l].critpercent:SetText(list[s].cperc)
				widget.list[l].critaverage:SetText(list[s].cavg)
				if list[s].count~="" then list[s].count=0 end
			end
		end
		widget.frame:Show()
	end
end

-- -----------------------------------------
-- BUTTON
-- -----------------------------------------
function Me:Button(button,fnk)
	if fnk=="reset" then Me:Command("reset")
	elseif fnk=="flip" then
		if not db.healer or not db.healer[playername] then 
			Me:Command("set")
		else
			db.healer[playername].show=not db.healer[playername].show
		end
		Me:ShowList()
	elseif fnk=="delete" then
		if db.healer and db.healer[playername] then
			local del=db.healer[playername].current
			Me:Button(button,"scroll")
			db.healer[playername].sets[del]=nil
		end
	elseif fnk=="scroll" then
		if db.healer and db.healer[playername] then
			local sets={}
			local size=0
			local current=0
			for set,data in pairs(db.healer[playername].sets) do
				size=size+1
				sets[size]=set
				if set==db.healer[playername].current then current=size end
			end
			current=current+1
			if current>size then current=1 end
			if size>0 then Me:Command("set "..sets[current]) end
		end
	end
end

-- -----------------------------------------
-- COMMAND
-- -----------------------------------------
function Me:Command(parm)
	local word=mod.core:Split(mod.core:Trim(string.lower(parm))," ")
	if word[1]=="reset" then
		if db.healer and db.healer[playername] then
			local set=db.healer[playername].current
			db.healer[playername].sets[set]={}
			stats=db.healer[playername].sets[set]
			Me:ShowList()
		end
	elseif word[1]=="rename" then
		if not word[2] or not word[3] then	mod.core:Print(L.msg.newnamemissing)
		elseif not db.healer or not db.healer[playername] or not db.healer[playername].sets[word[2]] then mod.core:Print(L.msg.unexistantset)
		elseif word[2]~=word[3] then
			db.healer[playername].sets[word[3]]={}
			for spell,data in pairs(db.healer[playername].sets[word[2]]) do
				db.healer[playername].sets[word[3]][spell]={regular={count=data.regular.count,amount=data.regular.amount},crit={count=data.crit.count,amount=data.crit.amount}}
			end
			db.healer[playername].sets[word[2]]=nil
			mod.core:Print(mod.core:Repl(L.msg.setrenamed,{"<old>","<new>"},{word[2],word[3]}))
			if db.healer[playername].current==word[2] then Me:Command("set "..word[2]) end
		end
	elseif word[1]=="set" then
		local set=word[2] or "normal"
		if not db.healer then db.healer={} end
		if not db.healer[playername] then db.healer[playername]={show=true,sets={}} end
		if not db.healer[playername].sets[set] then db.healer[playername].sets[set]={} end
		db.healer[playername].current=set
if set and db.healer[playername][set] and db.healer[playername][set].level then db.healer[playername][set].level=nil end -- just to get rid of obsolete value
		stats=db.healer[playername].sets[set]
		widget.title:SetText(string.upper(string.sub(set,1,1))..string.sub(set,2))
		Me:ShowList()
	elseif word[1]=="reinit" then
		db.healer[playername]=nil
		stats=nil
	else
		mod.core:Print(mod.core:Repl(L.msg.undefcmd,"<cmd>",(word[1] or "nil")))
	end
end